#ifndef SCC_GUARD_STD2_GLSL
#define SCC_GUARD_STD2_GLSL
#if defined VERTEX_SHADER
#ifndef SC_BLEND_MODE_CUSTOM
#define SC_BLEND_MODE_CUSTOM 0
#endif
#ifndef SC_BLEND_MODE_SCREEN
#define SC_BLEND_MODE_SCREEN 0
#endif
#ifndef SC_DEVICE_CLASS
#define SC_DEVICE_CLASS -1
#endif
#ifndef SC_GL_FRAGMENT_PRECISION_HIGH
#define SC_GL_FRAGMENT_PRECISION_HIGH 0
#endif
#ifndef SC_ENABLE_SRGB_EMULATION_IN_SHADER
#define SC_ENABLE_SRGB_EMULATION_IN_SHADER 0
#endif
#ifndef sc_AmbientLightsCount
#define sc_AmbientLightsCount 1
#endif
struct sc_AmbientLight_t
{
    vec3 color;
    float intensity;
    float weight;
    vec3 sphericalHarmonics[9];
    vec3 rotation;
    float exposure;
    mediump sampler2D diffuseEnvMap;
    mediump sampler2D specularEnvMap;
};
struct sc_PointLight_t
{
    vec3 position;
    vec4 color;
};
struct sc_DirectionalLight_t
{
    vec3 direction;
    vec4 color;
};
uniform sc_AmbientLight_t sc_AmbientLights[sc_AmbientLightsCount];
uniform vec4 sc_Time;
uniform mediump sampler2D sc_ScreenTexture;
uniform vec4 sc_RenderTargetSize;
uniform mat4 sc_ModelMatrix;
uniform mat4 sc_ModelViewProjectionMatrix;
uniform mat4 sc_ModelViewProjectionMatrixInverse;
#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
precision mediump float;
precision highp int;
#ifndef SC_BLEND_MODE_CUSTOM
#define SC_BLEND_MODE_CUSTOM 0
#endif
#ifndef SC_BLEND_MODE_SCREEN
#define SC_BLEND_MODE_SCREEN 0
#endif
#ifndef SC_DEVICE_CLASS
#define SC_DEVICE_CLASS -1
#endif
#ifndef SC_GL_FRAGMENT_PRECISION_HIGH
#define SC_GL_FRAGMENT_PRECISION_HIGH 0
#endif
#ifndef SC_ENABLE_SRGB_EMULATION_IN_SHADER
#define SC_ENABLE_SRGB_EMULATION_IN_SHADER 0
#endif
#ifndef sc_AmbientLightsCount
#define sc_AmbientLightsCount 1
#endif
struct sc_AmbientLight_t
{
    highp vec3 color;
    highp float intensity;
    highp float weight;
    highp vec3 sphericalHarmonics[9];
    highp vec3 rotation;
    highp float exposure;
    mediump sampler2D diffuseEnvMap;
    mediump sampler2D specularEnvMap;
};
struct sc_PointLight_t
{
    highp vec3 position;
    highp vec4 color;
};
struct sc_DirectionalLight_t
{
    highp vec3 direction;
    highp vec4 color;
};
uniform sc_AmbientLight_t sc_AmbientLights[sc_AmbientLightsCount];
uniform highp vec4 sc_Time;
uniform mediump sampler2D sc_ScreenTexture;
uniform highp vec4 sc_RenderTargetSize;
uniform highp mat4 sc_ModelMatrix;
uniform highp mat4 sc_ModelViewProjectionMatrix;
uniform highp mat4 sc_ModelViewProjectionMatrixInverse;
#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
#endif // #ifndef SCC_GUARD_STD2_GLSL
