#ifndef SCC_GUARD_STD2_VS_GLSL
#define SCC_GUARD_STD2_VS_GLSL
#if defined VERTEX_SHADER
#include <std2.glsl>
struct sc_Vertex_t
{
    vec4 position;
    vec3 normal;
    vec3 tangent;
    vec2 texture0;
    vec2 texture1;
};
#ifndef sc_RenderingSpace
#define sc_RenderingSpace -1
#endif
attribute vec4 position;
attribute vec3 normal;
attribute vec4 tangent;
attribute vec2 texture0;
attribute vec2 texture1;
varying vec3 varPos;
varying vec4 varTex01;
varying vec3 varNormal;
varying vec4 varTangent;
vec4 _73;
sc_Vertex_t sc_LoadVertexAttributes()
{
    sc_Vertex_t vertex;
    vertex.position = position;
    vertex.normal = normal;
    vertex.tangent = tangent.xyz;
    vertex.texture0 = texture0;
    vertex.texture1 = texture1;
    return vertex;
}
vec4 sc_ObjectToScreen(vec4 objectPosition)
{
    #if (sc_RenderingSpace == 3)
    {
        return objectPosition;
    }
    #else // #if (sc_RenderingSpace == 3)
    {
        #if (sc_RenderingSpace == 1)
        {
            return sc_ModelViewProjectionMatrix * objectPosition;
        }
        #endif // #if (sc_RenderingSpace == 1)
    }
    #endif // #else // #if (sc_RenderingSpace == 3)
}
void sc_ProcessVertex(sc_Vertex_t v)
{
    vec4 param = v.position;
    vec4 screenPosition = sc_ObjectToScreen(param);
    varPos = (sc_ModelMatrix * v.position).xyz;
    varTex01 = vec4(v.texture0, v.texture1);
    gl_Position = screenPosition * 1.0;
}
#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
#include <std2.glsl>
precision mediump float;
precision highp int;
#ifndef sc_RenderingSpace
#define sc_RenderingSpace -1
#endif
varying highp vec3 varPos;
varying highp vec3 varNormal;
varying highp vec4 varTangent;
varying highp vec4 varTex01;
#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
#endif // #ifndef SCC_GUARD_STD2_VS_GLSL
