//  Copyright Snap Inc. All rights reserved.
//  CameraKit

#import <Foundation/Foundation.h>
#import "SCCameraKitARInput.h"

@class ARSession;

NS_ASSUME_NONNULL_BEGIN

NS_SWIFT_NAME(ARSessionInput)
/// AVSessionInput is a CameraKit provided wrapper for AVCaptureSession. It may make adjustments to things like color formats in order to process frames. You are still responsible for doing the general configuration of the capture session, such as adding devices.
@interface SCCameraKitARSessionInput : NSObject <SCCameraKitARInput>

/// Create an AR Session input.
/// Inits with a managed ARSession
- (instancetype)init;

/// Create an AR Session input with a preexisting session.
/// @param session the AVCaptureSession to use.
/// @note the input will overwrite the preexisting settings for delegate and delegateQueue
- (instancetype)initWithSession:(ARSession *)session;

@end

NS_ASSUME_NONNULL_END
