//  Copyright Snap Inc. All rights reserved.
//  CameraKit

#import "SCCameraKitOutput.h"
#import "SCCameraKitOutputViewportProviding.h"

@class SCCameraKitSession;

NS_ASSUME_NONNULL_BEGIN

NS_SWIFT_NAME(PreviewView)
/// A UIView which is capable of rendering SCCameraKitTextures. You should add this as an output for your CameraKit instance.
@interface SCCameraKitPreviewView : UIView <SCCameraKitOutput, SCCameraKitOutputViewportProviding>

/// Configures the neccessary gesture recognizers for handling touch input in lenses.
/// If set to YES, will automatically add gesture reconizers and configure them to pass events to lenses.
/// @note by default, this is NO. You may change this to YES while cameraKit is running, and it will be configured on the next frame.
@property (assign, nonatomic) BOOL automaticallyConfiguresTouchHandler;

@end

NS_ASSUME_NONNULL_END
