//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: signals.proto
//
//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import Foundation
import GRPC
import NIO
import NIOHTTP1
import SwiftProtobuf


/// Usage: instantiate TrillerSignalsSignalServiceClient, then call methods of this protocol to make API calls.
public protocol TrillerSignalsSignalServiceClientProtocol: GRPCClient {
  func signal(
    callOptions: CallOptions?,
    handler: @escaping (TrillerSignalsStatus) -> Void
  ) -> BidirectionalStreamingCall<TrillerSignalsSignalRequest, TrillerSignalsStatus>

}

extension TrillerSignalsSignalServiceClientProtocol {

  /// Bidirectional streaming call to Signal
  ///
  /// Callers should use the `send` method on the returned object to send messages
  /// to the server. The caller should send an `.end` after the final message has been sent.
  ///
  /// - Parameters:
  ///   - callOptions: Call options.
  ///   - handler: A closure called when each response is received from the server.
  /// - Returns: A `ClientStreamingCall` with futures for the metadata and status.
  public func signal(
    callOptions: CallOptions? = nil,
    handler: @escaping (TrillerSignalsStatus) -> Void
  ) -> BidirectionalStreamingCall<TrillerSignalsSignalRequest, TrillerSignalsStatus> {
    return self.makeBidirectionalStreamingCall(
      path: "/triller.analysis.signals.SignalService/Signal",
      callOptions: callOptions ?? self.defaultCallOptions,
      handler: handler
    )
  }
}

public final class TrillerSignalsSignalServiceClient: TrillerSignalsSignalServiceClientProtocol {
  public let channel: GRPCChannel
  public var defaultCallOptions: CallOptions

  /// Creates a client for the triller.analysis.signals.SignalService service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  public init(channel: GRPCChannel, defaultCallOptions: CallOptions = CallOptions()) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
  }
}
