// DO NOT EDIT.
// swift-format-ignore-file
//
// Generated by the Swift generator plugin for the protocol buffer compiler.
// Source: signals.proto
//
// For information on using the generated types, please see the documentation:
//   https://github.com/apple/swift-protobuf/
import Foundation
import SwiftProtobuf

// If the compiler emits an error on this type, it is because this file
// was generated by a version of the `protoc` Swift plug-in that is
// incompatible with the version of SwiftProtobuf to which you are linking.
// Please ensure that you are building against the same version of the API
// that was used to generate this file.
fileprivate struct _GeneratedWithProtocGenSwiftVersion: SwiftProtobuf.ProtobufAPIVersionCheck {
  struct _2: SwiftProtobuf.ProtobufAPIVersion_2 {}
  typealias Version = _2
}

/// Never change the value associated with a type. LIKE must always be 1.
/// SHARE_INTENTION must always be 2 and so on for every value.
public enum TrillerSignalsSignalType: SwiftProtobuf.Enum {
  public typealias RawValue = Int
  case undefinedSignalType // = 0
  case like // = 1
  case shareIntention // = 2
  case viewedCreatorProfile // = 3
  case followedCreator // = 4
  case watchEvent // = 5
  case directMessage // = 6
  case comment // = 7
  case UNRECOGNIZED(Int)

  public init() {
    self = .undefinedSignalType
  }

  public init?(rawValue: Int) {
    switch rawValue {
    case 0: self = .undefinedSignalType
    case 1: self = .like
    case 2: self = .shareIntention
    case 3: self = .viewedCreatorProfile
    case 4: self = .followedCreator
    case 5: self = .watchEvent
    case 6: self = .directMessage
    case 7: self = .comment
    default: self = .UNRECOGNIZED(rawValue)
    }
  }

  public var rawValue: Int {
    switch self {
    case .undefinedSignalType: return 0
    case .like: return 1
    case .shareIntention: return 2
    case .viewedCreatorProfile: return 3
    case .followedCreator: return 4
    case .watchEvent: return 5
    case .directMessage: return 6
    case .comment: return 7
    case .UNRECOGNIZED(let i): return i
    }
  }

}

#if swift(>=4.2)

extension TrillerSignalsSignalType: CaseIterable {
  // The compiler won't synthesize support with the UNRECOGNIZED case.
  public static var allCases: [TrillerSignalsSignalType] = [
    .undefinedSignalType,
    .like,
    .shareIntention,
    .viewedCreatorProfile,
    .followedCreator,
    .watchEvent,
    .directMessage,
    .comment,
  ]
}

#endif  // swift(>=4.2)
public enum TrillerSignalsFeed: SwiftProtobuf.Enum {
  public typealias RawValue = Int
  case undefinedFeed // = 0
  case followFeed // = 1
  case sharedFeed // = 2
  case socialFeed // = 3
  case videoFeed // = 4
  case UNRECOGNIZED(Int)

  public init() {
    self = .undefinedFeed
  }

  public init?(rawValue: Int) {
    switch rawValue {
    case 0: self = .undefinedFeed
    case 1: self = .followFeed
    case 2: self = .sharedFeed
    case 3: self = .socialFeed
    case 4: self = .videoFeed
    default: self = .UNRECOGNIZED(rawValue)
    }
  }

  public var rawValue: Int {
    switch self {
    case .undefinedFeed: return 0
    case .followFeed: return 1
    case .sharedFeed: return 2
    case .socialFeed: return 3
    case .videoFeed: return 4
    case .UNRECOGNIZED(let i): return i
    }
  }

}

#if swift(>=4.2)

extension TrillerSignalsFeed: CaseIterable {
  // The compiler won't synthesize support with the UNRECOGNIZED case.
  public static var allCases: [TrillerSignalsFeed] = [
    .undefinedFeed,
    .followFeed,
    .sharedFeed,
    .socialFeed,
    .videoFeed,
  ]
}

#endif  // swift(>=4.2)
public struct TrillerSignalsEvent {
  // SwiftProtobuf.Message conformance is added in an extension below. See the
  // `Message` and `Message+*Additions` files in the SwiftProtobuf library for
  // methods supported on all messages.
  /// The id of the video for which this event occurred.
  /// @inject_tag: validate:"required"
  public var videoID: Int64 = 0

  /// The type of signal event.
  /// @inject_tag: validate:"required"
  public var signalType: TrillerSignalsSignalType = .undefinedSignalType

  /// The time at which the event occurred.
  /// @inject_tag: validate:"required"
  public var signalOccurredEpoch: SwiftProtobuf.Google_Protobuf_Timestamp {
    get {return _signalOccurredEpoch ?? SwiftProtobuf.Google_Protobuf_Timestamp()}
    set {_signalOccurredEpoch = newValue}
  }
  /// Returns true if `signalOccurredEpoch` has been explicitly set.
  public var hasSignalOccurredEpoch: Bool {return self._signalOccurredEpoch != nil}
  /// Clears the value of `signalOccurredEpoch`. Subsequent reads from it will return its default value.
  public mutating func clearSignalOccurredEpoch() {self._signalOccurredEpoch = nil}

  /// The duration in seconds that the video was watched at the time the event occurred (excluding any buffering time).
  /// If the event occurred during the buffering period then watch_time should be reported as 0.
  public var watchTime: Float = 0

  /// Optional ISRC code for the music track on the video, if music is present.
  /// Eg "US-S1Z-99-00001". See https://isrc.ifpi.org/en/
  /// NB.  This field is optional but should be included where possible to allow for better analysis of the effect
  /// of music on user engagement.
  public var trackIsrc: String = String()

  /// The feed in which this event occurred.
  /// @inject_tag: validate:"required"
  public var feedID: TrillerSignalsFeed = .undefinedFeed

  /// The id of the recommender who suggested this video to the feed.
  /// NB.  This field is currently optional, but may become required in future releases.
  /// Be sure to future proof clients against validation failures.
  public var feedRecommenderID: Int32 = 0

  /// the length of the video in seconds.
  public var videoLength: Float = 0

  public var unknownFields = SwiftProtobuf.UnknownStorage()

  public init() {}

  fileprivate var _signalOccurredEpoch: SwiftProtobuf.Google_Protobuf_Timestamp? = nil
}

public struct TrillerSignalsSignalRequest {
  // SwiftProtobuf.Message conformance is added in an extension below. See the
  // `Message` and `Message+*Additions` files in the SwiftProtobuf library for
  // methods supported on all messages.
  /// The id of the user performing the action.
  /// @inject_tag: validate:"required"
  public var userID: Int64 = 0

  /// A list of signal events for the user.
  /// @inject_tag: validate:"required,dive,required"
  public var events: [TrillerSignalsEvent] = []

  public var unknownFields = SwiftProtobuf.UnknownStorage()

  public init() {}
}

/// https://cloud.google.com/apis/design/errors#error_model
public struct TrillerSignalsStatus {
  // SwiftProtobuf.Message conformance is added in an extension below. See the
  // `Message` and `Message+*Additions` files in the SwiftProtobuf library for
  // methods supported on all messages.
  /// A simple error code that can be easily handled by the client. The
  /// actual error code is defined by `google.rpc.Code`.
  public var code: Int32 = 0

  /// A developer-facing human-readable error message in English. It should
  /// both explain the error and offer an actionable resolution to it.
  public var message: String = String()

  /// Additional error information that the client code can use to handle
  /// the error, such as retry delay or a help link.
  public var details: [SwiftProtobuf.Google_Protobuf_Any] = []

  public var unknownFields = SwiftProtobuf.UnknownStorage()

  public init() {}
}

// MARK: - Code below here is support for the SwiftProtobuf runtime.
fileprivate let _protobuf_package = "triller.analysis.signals"

extension TrillerSignalsSignalType: SwiftProtobuf._ProtoNameProviding {
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    0: .same(proto: "UNDEFINED_SIGNAL_TYPE"),
    1: .same(proto: "LIKE"),
    2: .same(proto: "SHARE_INTENTION"),
    3: .same(proto: "VIEWED_CREATOR_PROFILE"),
    4: .same(proto: "FOLLOWED_CREATOR"),
    5: .same(proto: "WATCH_EVENT"),
    6: .same(proto: "DIRECT_MESSAGE"),
    7: .same(proto: "COMMENT"),
  ]
}

extension TrillerSignalsFeed: SwiftProtobuf._ProtoNameProviding {
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    0: .same(proto: "UNDEFINED_FEED"),
    1: .same(proto: "FOLLOW_FEED"),
    2: .same(proto: "SHARED_FEED"),
    3: .same(proto: "SOCIAL_FEED"),
    4: .same(proto: "VIDEO_FEED"),
  ]
}

extension TrillerSignalsEvent: SwiftProtobuf.Message, SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  public static let protoMessageName: String = _protobuf_package + ".Event"
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .standard(proto: "video_id"),
    2: .standard(proto: "signal_type"),
    3: .standard(proto: "signal_occurred_epoch"),
    4: .standard(proto: "watch_time"),
    5: .standard(proto: "track_isrc"),
    6: .standard(proto: "feed_id"),
    7: .standard(proto: "feed_recommender_id"),
    8: .standard(proto: "video_length"),
  ]

  public mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    while let fieldNumber = try decoder.nextFieldNumber() {
      switch fieldNumber {
      case 1: try decoder.decodeSingularInt64Field(value: &self.videoID)
      case 2: try decoder.decodeSingularEnumField(value: &self.signalType)
      case 3: try decoder.decodeSingularMessageField(value: &self._signalOccurredEpoch)
      case 4: try decoder.decodeSingularFloatField(value: &self.watchTime)
      case 5: try decoder.decodeSingularStringField(value: &self.trackIsrc)
      case 6: try decoder.decodeSingularEnumField(value: &self.feedID)
      case 7: try decoder.decodeSingularInt32Field(value: &self.feedRecommenderID)
      case 8: try decoder.decodeSingularFloatField(value: &self.videoLength)
      default: break
      }
    }
  }

  public func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    if self.videoID != 0 {
      try visitor.visitSingularInt64Field(value: self.videoID, fieldNumber: 1)
    }
    if self.signalType != .undefinedSignalType {
      try visitor.visitSingularEnumField(value: self.signalType, fieldNumber: 2)
    }
    if let v = self._signalOccurredEpoch {
      try visitor.visitSingularMessageField(value: v, fieldNumber: 3)
    }
    if self.watchTime != 0 {
      try visitor.visitSingularFloatField(value: self.watchTime, fieldNumber: 4)
    }
    if !self.trackIsrc.isEmpty {
      try visitor.visitSingularStringField(value: self.trackIsrc, fieldNumber: 5)
    }
    if self.feedID != .undefinedFeed {
      try visitor.visitSingularEnumField(value: self.feedID, fieldNumber: 6)
    }
    if self.feedRecommenderID != 0 {
      try visitor.visitSingularInt32Field(value: self.feedRecommenderID, fieldNumber: 7)
    }
    if self.videoLength != 0 {
      try visitor.visitSingularFloatField(value: self.videoLength, fieldNumber: 8)
    }
    try unknownFields.traverse(visitor: &visitor)
  }

  public static func ==(lhs: TrillerSignalsEvent, rhs: TrillerSignalsEvent) -> Bool {
    if lhs.videoID != rhs.videoID {return false}
    if lhs.signalType != rhs.signalType {return false}
    if lhs._signalOccurredEpoch != rhs._signalOccurredEpoch {return false}
    if lhs.watchTime != rhs.watchTime {return false}
    if lhs.trackIsrc != rhs.trackIsrc {return false}
    if lhs.feedID != rhs.feedID {return false}
    if lhs.feedRecommenderID != rhs.feedRecommenderID {return false}
    if lhs.videoLength != rhs.videoLength {return false}
    if lhs.unknownFields != rhs.unknownFields {return false}
    return true
  }
}

extension TrillerSignalsSignalRequest: SwiftProtobuf.Message, SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  public static let protoMessageName: String = _protobuf_package + ".SignalRequest"
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .standard(proto: "user_id"),
    2: .same(proto: "events"),
  ]

  public mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    while let fieldNumber = try decoder.nextFieldNumber() {
      switch fieldNumber {
      case 1: try decoder.decodeSingularInt64Field(value: &self.userID)
      case 2: try decoder.decodeRepeatedMessageField(value: &self.events)
      default: break
      }
    }
  }

  public func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    if self.userID != 0 {
      try visitor.visitSingularInt64Field(value: self.userID, fieldNumber: 1)
    }
    if !self.events.isEmpty {
      try visitor.visitRepeatedMessageField(value: self.events, fieldNumber: 2)
    }
    try unknownFields.traverse(visitor: &visitor)
  }

  public static func ==(lhs: TrillerSignalsSignalRequest, rhs: TrillerSignalsSignalRequest) -> Bool {
    if lhs.userID != rhs.userID {return false}
    if lhs.events != rhs.events {return false}
    if lhs.unknownFields != rhs.unknownFields {return false}
    return true
  }
}

extension TrillerSignalsStatus: SwiftProtobuf.Message, SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  public static let protoMessageName: String = _protobuf_package + ".Status"
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .same(proto: "code"),
    2: .same(proto: "message"),
    3: .same(proto: "details"),
  ]

  public mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    while let fieldNumber = try decoder.nextFieldNumber() {
      switch fieldNumber {
      case 1: try decoder.decodeSingularInt32Field(value: &self.code)
      case 2: try decoder.decodeSingularStringField(value: &self.message)
      case 3: try decoder.decodeRepeatedMessageField(value: &self.details)
      default: break
      }
    }
  }

  public func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    if self.code != 0 {
      try visitor.visitSingularInt32Field(value: self.code, fieldNumber: 1)
    }
    if !self.message.isEmpty {
      try visitor.visitSingularStringField(value: self.message, fieldNumber: 2)
    }
    if !self.details.isEmpty {
      try visitor.visitRepeatedMessageField(value: self.details, fieldNumber: 3)
    }
    try unknownFields.traverse(visitor: &visitor)
  }

  public static func ==(lhs: TrillerSignalsStatus, rhs: TrillerSignalsStatus) -> Bool {
    if lhs.code != rhs.code {return false}
    if lhs.message != rhs.message {return false}
    if lhs.details != rhs.details {return false}
    if lhs.unknownFields != rhs.unknownFields {return false}
    return true
  }
}
