import Foundation
import GRPC
import NIO
@testable import Networking

class FakeStreamFactory: StreamFactory {

    var channel: FakeChannel = .init()
    var authToken: String?
    var request: FakeRequestPart<TrillerSignalsSignalRequest>?
    var response: FakeStreamingResponse<TrillerSignalsSignalRequest, TrillerSignalsStatus>?

    func buildStream(service: TrillerSignalsSignalServiceClientProtocol,
                     authToken: String)
                     -> BidirectionalStreamingCall<TrillerSignalsSignalRequest, TrillerSignalsStatus> {
        self.authToken = authToken
        self.response = channel.makeFakeStreamingResponse(path: "") { (request: FakeRequestPart<TrillerSignalsSignalRequest>) in
            self.request = request
        }
        return channel.makeBidirectionalStreamingCall(path: "", callOptions: CallOptions()) { _ in

        }
    }

}
